Bug 185970

Summary: lang/gcc-aux LICENSE is (grossly) incorrect
Product: Ports & Packages Reporter: gerald
Component: Individual Port(s)Assignee: John Marino <marino>
Status: Closed FIXED    
Severity: Affects Only Me    
Priority: Normal    
Version: Latest   
Hardware: Any   
OS: Any   

Description gerald 2014-01-21 20:00:00 UTC
	The entry LICENSE=GPLv3 applies to large parts of the compiler
	but is utterly and totally incorrect as it comes to the run time
	provided by this port.  GCC has gone to great lengths not to
	render software built with GCC and/or linking against its run-
	time libraries free software as well, among others by virtue
	of the run-time exceptions in the license.

	The current statement grossly misrepresents this and can easily
	to people drawing incorrect conclusions.

How-To-Repeat: 	Cf. 
	// Under Section 7 of GPL version 3, you are granted additional
	// permissions described in the GCC Runtime Library Exception, version
	// 3.1, as published by the Free Software Foundation.
	in many files under libstdc++/src for example.
Comment 1 Edwin Groothuis freebsd_committer 2014-01-21 20:00:08 UTC
Responsible Changed
From-To: freebsd-ports-bugs->marino

Over to maintainer (via the GNATS Auto Assign Tool)
Comment 2 freebsd.contact 2014-01-21 20:21:49 UTC
You didn't say how you think it should be "fixed", so I interpret you
think that the LICENSE should be undefined.

There is obviously no single description that is completely accurate to
describe gcc.  The Ada runtime has yet even a different exception
(unless it's been merged with GPLv3 runtime exception).

In any case, I do not expect people to use the FreeBSD ports LICENSE
description as their legal guidance.  I can't envision somebody deciding
GCC rendered their produced binary as GPLv3 based on the port metadata
and completely ignore gnu.org and fsf.org over it.

Likewise there are plenty of ports marked as "BSD" but the license isn't
actually BSD, just something very, very similar.  If "undefined" is
better than than a description that is accurate for 90% of the package,
then the entire LICENSE framework is useless (and that's possible.)

Or alternatively, if I presented this port to 20 developers and say,
"pick an entry for LICENSE from the existing definitions", would the
majority pick GPLv3?  If not, which would they pick?

The title says it's "Grossly incorrect", I think that's a very harsh and
pedantic stance.  Given that the exception is part of the license
(section 7), how its it not GPLv3?  or incorrect at all?
Comment 3 Eitan Adler freebsd_committer freebsd_triage 2014-01-24 17:50:38 UTC
I agree that that LICENSE=GPLv3 is wrong since the license is actually
GPLv3+section 7 conditions.

The solution here is to create treat this as a custom license and
follow the documentation for that. Be sure to set LICENSE_FILE to the
appropriate file.

-- 
Eitan Adler
Comment 4 freebsd.contact 2014-02-03 11:13:05 UTC
Gerald,
You need to respond to this PR about what you think should happen
otherwise I'm just going to close it.

Not only do I get frequent annoying "open PR" reminders about it, it's
shown (curiously) as a "critical" problem, which obviously it's not.

Clearly the outcome affects lang/gccXX ports as well.  If Eitan is going
to come up with some defined GCC license then we need to get that done
pretty quickly as well.

Thanks,
John
Comment 5 Eitan Adler freebsd_committer freebsd_triage 2014-02-03 22:14:22 UTC
On Mon, Feb 3, 2014 at 6:13 AM, John Marino <freebsd.contact@marino.st> wrote:

> Clearly the outcome affects lang/gccXX ports as well.  If Eitan is going
> to come up with some defined GCC license then we need to get that done
> pretty quickly as well.

I don't have time to deal with the gcc licensing issue.  I'd probably
just drop the LICENSE= line until I have time properly deal with this
again.

-- 
Eitan Adler
Source, Ports, Doc committer
Bugmeister, Ports Security teams
Comment 6 gerald 2014-02-03 22:42:39 UTC
On Tue, 21 Jan 2014, John Marino wrote:
> You didn't say how you think it should be "fixed", so I interpret you
> think that the LICENSE should be undefined.
> 
> There is obviously no single description that is completely accurate 
> to describe gcc.  The Ada runtime has yet even a different exception
> (unless it's been merged with GPLv3 runtime exception).

Yes, that is the challenge.  I will admit that I don't have a good
answer myself, or I would have implemented that in the lang/gcc4x
ports or made a concrete proposal in this PR.

> In any case, I do not expect people to use the FreeBSD ports LICENSE
> description as their legal guidance.  I can't envision somebody deciding
> GCC rendered their produced binary as GPLv3 based on the port metadata
> and completely ignore gnu.org and fsf.org over it.

Maybe, or even likely for critical environments.  However ...

> Likewise there are plenty of ports marked as "BSD" but the license isn't
> actually BSD, just something very, very similar.  If "undefined" is
> better than than a description that is accurate for 90% of the package,
> then the entire LICENSE framework is useless (and that's possible.)

... here we are not looking at something very, very similar.  The
difference here is about software being built by this port and using
its run-time libraries becoming free software by virtue of the "virality" 
of the GPL or being able to remain proprietary.

That is a huge difference and there has been quite a bit of FUD and
confusion around this in the context of FreeBSD already.  (Not caused
by this port or its maintainer, mind!)

Gerald
Comment 7 gerald 2014-02-04 01:18:28 UTC
On Mon, 3 Feb 2014, John Marino wrote:
> You need to respond to this PR about what you think should happen
> otherwise I'm just going to close it.

I'm sorry, catching up from my involuntarily being (mostly) offline
for weeks, per my mail to developers@ back then.

> Clearly the outcome affects lang/gccXX ports as well.  If Eitan is going
> to come up with some defined GCC license then we need to get that done
> pretty quickly as well.

Yes, I'd love to have a nice solution that we could also use for
the gcc4x ports.  I'm not sufficiently familiar with the license 
framework, unfortunately, and generally cautious assessing the
license of such a large body of code.

Gerald
Comment 8 dfilter service freebsd_committer 2014-02-12 23:40:05 UTC
Author: marino
Date: Wed Feb 12 23:39:58 2014
New Revision: 344035
URL: http://svnweb.freebsd.org/changeset/ports/344035
QAT: https://qat.redports.org/buildarchive/r344035/

Log:
  lang/gnat-aux: Add GPLv3RLE license requirement
  
  PR:		ports/185970
  submitted by:	gerald@

Modified:
  head/lang/gnat-aux/Makefile

Modified: head/lang/gnat-aux/Makefile
==============================================================================
--- head/lang/gnat-aux/Makefile	Wed Feb 12 23:34:19 2014	(r344034)
+++ head/lang/gnat-aux/Makefile	Wed Feb 12 23:39:58 2014	(r344035)
@@ -3,7 +3,7 @@
 
 PORTNAME=	gnat-aux
 PORTVERSION=	${SNAPSHOT}
-PORTREVISION=	1
+PORTREVISION=	2
 CATEGORIES=	lang
 MASTER_SITES=	http://downloads.dragonlace.net/src/:boot \
 		${MASTER_SITE_GCC}
@@ -13,7 +13,8 @@ DISTFILES=	gcc-core-${GCC_VERSION}.tar.b
 MAINTAINER=	marino@FreeBSD.org
 COMMENT=	GNAT Ada compiler based on GCC ${GCC_BRANCH}
 
-LICENSE=	GPLv3
+LICENSE=	GPLv3 GPLv3RLE
+LICENSE_COMB=	multi
 
 DEPRECATED=	Superceded by gcc4.7-based lang/gcc-aux, use it instead
 EXPIRATION_DATE=2014-06-01
_______________________________________________
svn-ports-all@freebsd.org mailing list
http://lists.freebsd.org/mailman/listinfo/svn-ports-all
To unsubscribe, send any mail to "svn-ports-all-unsubscribe@freebsd.org"
Comment 9 John Marino freebsd_committer 2014-02-12 23:52:30 UTC
State Changed
From-To: open->closed

New license GPLv3RLE defined, it is new additional requirement for gcc 
ports (gcc-aux, gnat-aux)